/**
 * This file was automatically generated by openapi-codegeneration.
 * DO NOT MODIFY IT BY HAND. Instead, modify the source OpenAPI file,
 * and run openapi-codegeneration to regenerate this file.
 */
import { ResponseData, type Require, AuthenticationServiceTypes, DeviceServiceTypes, ExperimentServiceTypes, FederationServiceTypes, LTIServiceTypes } from "./types.js";
import { AuthenticationServiceSignatures, DeviceServiceSignatures, ExperimentServiceSignatures, FederationServiceSignatures, LTIServiceSignatures } from "./signatures.js";
/**
 * This error class should be used if an error occurs during validation of a request/response.
 * @category Errors
 */
export declare class ValidationError extends Error {
    errors: any;
    constructor(message: string, errors: any);
}
/**
 * This error class should be used if an error occurs while fetching a request.
 * @category Errors
 */
export declare class FetchError extends Error {
    constructor(message: string);
}
/**
 * This error class should be used if the response of the server has a status
 * greater than or equal to 400. This error should contain the validated response.
 * @category Errors
 */
export declare class UnsuccessfulRequestError extends Error {
    response: ResponseData;
    constructor(message: string, response: ResponseData);
}
/**
 * This error class should be used if the validation of an url fails.
 * @category Errors
 */
export declare class InvalidUrlError extends Error {
    constructor(message: string);
}
/**
 * Client for the use of the Crosslab API
 * @category Client
 */
export declare class APIClient {
    private _url;
    private _accessToken;
    private fetch;
    /**
     * @category Constructors
     */
    constructor(url: string, accessToken?: string);
    /**
     * @category Accessors
     */
    get url(): string;
    /**
     * @category Accessors
     */
    set url(url: string);
    /**
     * @category Accessors
     */
    set accessToken(accessToken: string);
    /**
     * @category Accessors
     */
    get accessToken(): string; /**
     * Login user
     *
     * @param username
     * Username of the user.
     * @param password
     * Password of the user.
     * @param options.method
     * Authentication method.
     *
     * @throws {@link FetchError | FetchError }
     * Thrown if fetch fails.
     * @throws {@link ValidationError | ValidationError }
     * Thrown if the request/response validation fails.
     * @throws {@link InvalidUrlError | InvalidUrlError }
     * Thrown if the provided url is not valid for this request.
     * @throws {@link UnsuccessfulRequestError | UnsuccessfulRequestError }
     * Thrown if response is validated but has status greater than or equal to 400.
     *
     * @returns
     * Return the access token.
     *
     * @category Authentication Service Methods
     */
    login(username: string, password: string, options?: {
        headers?: [string, string][];
        method?: "tui" | "local";
    }): Promise<void>; /**
     * Logout user
     *
     * @throws {@link FetchError | FetchError }
     * Thrown if fetch fails.
     * @throws {@link ValidationError | ValidationError }
     * Thrown if the request/response validation fails.
     * @throws {@link InvalidUrlError | InvalidUrlError }
     * Thrown if the provided url is not valid for this request.
     * @throws {@link UnsuccessfulRequestError | UnsuccessfulRequestError }
     * Thrown if response is validated but has status greater than or equal to 400.
     *
     * @returns
     * Successfully logged out the user.
     *
     * @category Authentication Service Methods
     */
    logout(options?: {
        headers?: [string, string][];
    }): Promise<void>; /**
     * Get all users
     *
     * @param options.username
     * filter for users with a specific username
     * @param options.url
     * Url of the Authentication Service to be used.
     *
     * @throws {@link FetchError | FetchError }
     * Thrown if fetch fails.
     * @throws {@link ValidationError | ValidationError }
     * Thrown if the request/response validation fails.
     * @throws {@link InvalidUrlError | InvalidUrlError }
     * Thrown if the provided url is not valid for this request.
     * @throws {@link UnsuccessfulRequestError | UnsuccessfulRequestError }
     * Thrown if response is validated but has status greater than or equal to 400.
     *
     * @returns
     * The JSON representation of the users.
     *
     * @category Authentication Service Methods
     */
    listUsers(options?: {
        headers?: [string, string][];
        username?: string;
        url?: string;
    }): Promise<AuthenticationServiceSignatures.ListUsersSuccessResponse["body"]>; /**
     * Create a user
     *
     * @param user
     * User to be created.
     * @param options.url
     * Url of the Authentication Service to be used.
     *
     * @throws {@link FetchError | FetchError }
     * Thrown if fetch fails.
     * @throws {@link ValidationError | ValidationError }
     * Thrown if the request/response validation fails.
     * @throws {@link InvalidUrlError | InvalidUrlError }
     * Thrown if the provided url is not valid for this request.
     * @throws {@link UnsuccessfulRequestError | UnsuccessfulRequestError }
     * Thrown if response is validated but has status greater than or equal to 400.
     *
     * @returns
     * The JSON representation of the created user.
     *
     * @category Authentication Service Methods
     */
    createUser(user: Require<AuthenticationServiceTypes.User<"request">, "username" | "password">, options?: {
        headers?: [string, string][];
        url?: string;
    }): Promise<AuthenticationServiceSignatures.CreateUserSuccessResponse["body"]>; /**
     * Get a user
     *
     * @param url
     * Url of the resource to be accessed.
     *
     * @throws {@link FetchError | FetchError }
     * Thrown if fetch fails.
     * @throws {@link ValidationError | ValidationError }
     * Thrown if the request/response validation fails.
     * @throws {@link InvalidUrlError | InvalidUrlError }
     * Thrown if the provided url is not valid for this request.
     * @throws {@link UnsuccessfulRequestError | UnsuccessfulRequestError }
     * Thrown if response is validated but has status greater than or equal to 400.
     *
     * @returns
     * The JSON respresentation of the user.
     *
     * @category Authentication Service Methods
     */
    getUser(url: string, options?: {
        headers?: [string, string][];
    }): Promise<AuthenticationServiceSignatures.GetUserSuccessResponse["body"]>; /**
     * Update a user
     *
     * @param url
     * Url of the resource to be accessed.
     * @param user
     * Updated user
     *
     * @throws {@link FetchError | FetchError }
     * Thrown if fetch fails.
     * @throws {@link ValidationError | ValidationError }
     * Thrown if the request/response validation fails.
     * @throws {@link InvalidUrlError | InvalidUrlError }
     * Thrown if the provided url is not valid for this request.
     * @throws {@link UnsuccessfulRequestError | UnsuccessfulRequestError }
     * Thrown if response is validated but has status greater than or equal to 400.
     *
     * @returns
     * The JSON representation of the updated user.
     *
     * @category Authentication Service Methods
     */
    updateUser(url: string, user: AuthenticationServiceTypes.User<"request">, options?: {
        headers?: [string, string][];
    }): Promise<AuthenticationServiceSignatures.UpdateUserSuccessResponse["body"]>; /**
     * Delete a user
     *
     * @param url
     * Url of the resource to be accessed.
     *
     * @throws {@link FetchError | FetchError }
     * Thrown if fetch fails.
     * @throws {@link ValidationError | ValidationError }
     * Thrown if the request/response validation fails.
     * @throws {@link InvalidUrlError | InvalidUrlError }
     * Thrown if the provided url is not valid for this request.
     * @throws {@link UnsuccessfulRequestError | UnsuccessfulRequestError }
     * Thrown if response is validated but has status greater than or equal to 400.
     *
     * @returns
     * User deleted successfully
     *
     * @category Authentication Service Methods
     */
    deleteUser(url: string, options?: {
        headers?: [string, string][];
    }): Promise<void>; /**
     * Get identity
     *
     * @throws {@link FetchError | FetchError }
     * Thrown if fetch fails.
     * @throws {@link ValidationError | ValidationError }
     * Thrown if the request/response validation fails.
     * @throws {@link InvalidUrlError | InvalidUrlError }
     * Thrown if the provided url is not valid for this request.
     * @throws {@link UnsuccessfulRequestError | UnsuccessfulRequestError }
     * Thrown if response is validated but has status greater than or equal to 400.
     *
     * @returns
     * The JSON representation of the corresponding user.
     *
     * @category Authentication Service Methods
     */
    getIdentity(options?: {
        headers?: [string, string][];
    }): Promise<AuthenticationServiceSignatures.GetIdentitySuccessResponse["body"]>; /**
     * Update identity
     *
     * @param user
     * Updated identity.
     *
     * @throws {@link FetchError | FetchError }
     * Thrown if fetch fails.
     * @throws {@link ValidationError | ValidationError }
     * Thrown if the request/response validation fails.
     * @throws {@link InvalidUrlError | InvalidUrlError }
     * Thrown if the provided url is not valid for this request.
     * @throws {@link UnsuccessfulRequestError | UnsuccessfulRequestError }
     * Thrown if response is validated but has status greater than or equal to 400.
     *
     * @returns
     * The JSON representation of the updated user.
     *
     * @category Authentication Service Methods
     */
    updateIdentity(user: AuthenticationServiceTypes.User<"request">, options?: {
        headers?: [string, string][];
    }): Promise<AuthenticationServiceSignatures.UpdateIdentitySuccessResponse["body"]>; /**
     * Create a new token
     *
     * @param body
     *
     * @throws {@link FetchError | FetchError }
     * Thrown if fetch fails.
     * @throws {@link ValidationError | ValidationError }
     * Thrown if the request/response validation fails.
     * @throws {@link InvalidUrlError | InvalidUrlError }
     * Thrown if the provided url is not valid for this request.
     * @throws {@link UnsuccessfulRequestError | UnsuccessfulRequestError }
     * Thrown if response is validated but has status greater than or equal to 400.
     *
     * @returns
     * The token was created successfully.
     *
     * @category Authentication Service Methods
     */
    createToken(body: {
        /**
         * Url or uuid of the user that will be used to create the token.
         */
        user: string;
        /**
         * The claims that will be added to the token. If left empty, the token will have the full scope of the user.
         *
         */
        claims?: {
            [k: string]: unknown;
        };
        [k: string]: unknown;
    } | {
        /**
         * Url or uuid of the user that will be used to create the token.
         */
        username: string;
        /**
         * The claims that will be added to the token. If left empty, the token will have the full scope of the user.
         *
         */
        claims?: {
            [k: string]: unknown;
        };
        [k: string]: unknown;
    }, options?: {
        headers?: [string, string][];
    }): Promise<AuthenticationServiceSignatures.CreateTokenSuccessResponse["body"]>; /**
     * List devices
     *
     * @param options.url
     * Url of the Device Service to be used.
     *
     * @throws {@link FetchError | FetchError }
     * Thrown if fetch fails.
     * @throws {@link ValidationError | ValidationError }
     * Thrown if the request/response validation fails.
     * @throws {@link InvalidUrlError | InvalidUrlError }
     * Thrown if the provided url is not valid for this request.
     * @throws {@link UnsuccessfulRequestError | UnsuccessfulRequestError }
     * Thrown if response is validated but has status greater than or equal to 400.
     *
     * @returns
     * The list of all devices.
     *
     * @category Device Service Methods
     */
    listDevices(options?: {
        headers?: [string, string][];
        url?: string;
    }): Promise<DeviceServiceSignatures.ListDevicesSuccessResponse["body"]>; /**
     * Create a new device
     *
     * @param device
     * The device to be created.
     * @param options.changedUrl
     * **An URL that will be called once the device changes.**
     *
     * Once the device was given a changedUrl parameter the contained URL will be called every time a device is changed
     * as long as every callback resolves with a successful status code.
     *
     * If the callback fails the url MIGHT not be called in the future.
     *
     * There can be multiple callbacks registered with the same device.
     * @param options.url
     * Url of the Device Service to be used.
     *
     * @throws {@link FetchError | FetchError }
     * Thrown if fetch fails.
     * @throws {@link ValidationError | ValidationError }
     * Thrown if the request/response validation fails.
     * @throws {@link InvalidUrlError | InvalidUrlError }
     * Thrown if the provided url is not valid for this request.
     * @throws {@link UnsuccessfulRequestError | UnsuccessfulRequestError }
     * Thrown if response is validated but has status greater than or equal to 400.
     *
     * @returns
     * The device was created. A JSON representation of the new device is returned.
     *
     * @category Device Service Methods
     */
    createDevice(device: DeviceServiceTypes.Device<"request">, options?: {
        headers?: [string, string][];
        changedUrl?: string;
        url?: string;
    }): Promise<DeviceServiceSignatures.CreateDeviceSuccessResponse["body"]>; /**
     * View a registered device
     *
     * @param url
     * Url of the resource to be accessed.
     * @param options.flat_group
     * If true the returned device group will only contain concrete devices. I.e. any subgroups will be flattend.
     *
     * @throws {@link FetchError | FetchError }
     * Thrown if fetch fails.
     * @throws {@link ValidationError | ValidationError }
     * Thrown if the request/response validation fails.
     * @throws {@link InvalidUrlError | InvalidUrlError }
     * Thrown if the provided url is not valid for this request.
     * @throws {@link UnsuccessfulRequestError | UnsuccessfulRequestError }
     * Thrown if response is validated but has status greater than or equal to 400.
     *
     * @returns
     * The JSON Representation of the device.
     *
     * @category Device Service Methods
     */
    getDevice(url: string, options?: {
        headers?: [string, string][];
        flat_group?: boolean;
    }): Promise<DeviceServiceSignatures.GetDeviceSuccessResponse["body"]>; /**
     * Update an existing device
     *
     * @param url
     * Url of the resource to be accessed.
     * @param deviceUpdate
     * Updated device.
     * @param options.changedUrl
     * **An URL that will be called once the device changes.**
     *
     * Once the device was given a changedUrl parameter the contained URL will be called every time a device is changed
     * as long as every callback resolves with a successful status code.
     *
     * If the callback fails the url MIGHT not be called in the future.
     *
     * There can be multiple callbacks registered with the same device.
     *
     * @throws {@link FetchError | FetchError }
     * Thrown if fetch fails.
     * @throws {@link ValidationError | ValidationError }
     * Thrown if the request/response validation fails.
     * @throws {@link InvalidUrlError | InvalidUrlError }
     * Thrown if the provided url is not valid for this request.
     * @throws {@link UnsuccessfulRequestError | UnsuccessfulRequestError }
     * Thrown if response is validated but has status greater than or equal to 400.
     *
     * @returns
     * The JSON Representation of the changed device.
     *
     * @category Device Service Methods
     */
    updateDevice(url: string, deviceUpdate: DeviceServiceTypes.DeviceUpdate<"request">, options?: {
        headers?: [string, string][];
        changedUrl?: string;
    }): Promise<DeviceServiceSignatures.UpdateDeviceSuccessResponse["body"]>; /**
     * Delete a registered device
     *
     * @param url
     * Url of the resource to be accessed.
     *
     * @throws {@link FetchError | FetchError }
     * Thrown if fetch fails.
     * @throws {@link ValidationError | ValidationError }
     * Thrown if the request/response validation fails.
     * @throws {@link InvalidUrlError | InvalidUrlError }
     * Thrown if the provided url is not valid for this request.
     * @throws {@link UnsuccessfulRequestError | UnsuccessfulRequestError }
     * Thrown if response is validated but has status greater than or equal to 400.
     *
     * @returns
     * The device was deleted.
     *
     * @category Device Service Methods
     */
    deleteDevice(url: string, options?: {
        headers?: [string, string][];
    }): Promise<void>; /**
     * Instantiate a cloud instantiable device
     *
     * @param url
     * Url of the resource to be accessed.
     * @param options.changedUrl
     * **An URL that will be called once the device changes.**
     *
     * Once the device was given a changedUrl parameter the contained URL will be called every time a device is changed
     * as long as every callback resolves with a successful status code.
     *
     * If the callback fails the url MIGHT not be called in the future.
     *
     * There can be multiple callbacks registered with the same device.
     *
     * @throws {@link FetchError | FetchError }
     * Thrown if fetch fails.
     * @throws {@link ValidationError | ValidationError }
     * Thrown if the request/response validation fails.
     * @throws {@link InvalidUrlError | InvalidUrlError }
     * Thrown if the provided url is not valid for this request.
     * @throws {@link UnsuccessfulRequestError | UnsuccessfulRequestError }
     * Thrown if response is validated but has status greater than or equal to 400.
     *
     * @returns
     * The JSON Representation of the created instance.
     *
     * @category Device Service Methods
     */
    instantiateDevice(url: string, options?: {
        headers?: [string, string][];
        changedUrl?: string;
    }): Promise<DeviceServiceSignatures.InstantiateDeviceSuccessResponse["body"]>; /**
     * Get the availability of a device
     *
     * @param url
     * Url of the resource to be accessed.
     * @param options.startTime
     * Start time of the requested availability
     * @param options.endTime
     * End time of the requested availability
     *
     * @throws {@link FetchError | FetchError }
     * Thrown if fetch fails.
     * @throws {@link ValidationError | ValidationError }
     * Thrown if the request/response validation fails.
     * @throws {@link InvalidUrlError | InvalidUrlError }
     * Thrown if the provided url is not valid for this request.
     * @throws {@link UnsuccessfulRequestError | UnsuccessfulRequestError }
     * Thrown if response is validated but has status greater than or equal to 400.
     *
     * @returns
     * The JSON Representation of the availability of the device.
     *
     * @category Device Service Methods
     */
    getDeviceAvailability(url: string, options?: {
        headers?: [string, string][];
        startTime?: string;
        endTime?: string;
    }): Promise<DeviceServiceSignatures.GetDeviceAvailabilitySuccessResponse["body"]>; /**
     * Delete the availability rules of a device
     *
     * @param url
     * Url of the resource to be accessed.
     *
     * @throws {@link FetchError | FetchError }
     * Thrown if fetch fails.
     * @throws {@link ValidationError | ValidationError }
     * Thrown if the request/response validation fails.
     * @throws {@link InvalidUrlError | InvalidUrlError }
     * Thrown if the provided url is not valid for this request.
     * @throws {@link UnsuccessfulRequestError | UnsuccessfulRequestError }
     * Thrown if response is validated but has status greater than or equal to 400.
     *
     * @returns
     * The availability rules of the device were deleted successfully.
     *
     * @category Device Service Methods
     */
    deleteDeviceAvailabilityRules(url: string, options?: {
        headers?: [string, string][];
    }): Promise<void>; /**
     * Add availability rules for a device
     *
     * @param url
     * Url of the resource to be accessed.
     * @param availabilityRules
     * The availability rules to be applied.
     *
     * @throws {@link FetchError | FetchError }
     * Thrown if fetch fails.
     * @throws {@link ValidationError | ValidationError }
     * Thrown if the request/response validation fails.
     * @throws {@link InvalidUrlError | InvalidUrlError }
     * Thrown if the provided url is not valid for this request.
     * @throws {@link UnsuccessfulRequestError | UnsuccessfulRequestError }
     * Thrown if response is validated but has status greater than or equal to 400.
     *
     * @returns
     * The JSON Representation of the changed availability.
     *
     * @category Device Service Methods
     */
    addDeviceAvailabilityRules(url: string, availabilityRules: DeviceServiceTypes.AvailabilityRule<"request">[], options?: {
        headers?: [string, string][];
    }): Promise<DeviceServiceSignatures.AddDeviceAvailabilityRulesSuccessResponse["body"]>; /**
     * Create new websocket token for device
     *
     * @param url
     * Url of the resource to be accessed.
     *
     * @throws {@link FetchError | FetchError }
     * Thrown if fetch fails.
     * @throws {@link ValidationError | ValidationError }
     * Thrown if the request/response validation fails.
     * @throws {@link InvalidUrlError | InvalidUrlError }
     * Thrown if the provided url is not valid for this request.
     * @throws {@link UnsuccessfulRequestError | UnsuccessfulRequestError }
     * Thrown if response is validated but has status greater than or equal to 400.
     *
     * @returns
     * The newly generated websocket token for the device.
     *
     * @category Device Service Methods
     */
    createWebsocketToken(url: string, options?: {
        headers?: [string, string][];
    }): Promise<DeviceServiceSignatures.CreateWebsocketTokenSuccessResponse["body"]>; /**
     * Send signaling message to device
     *
     * @param url
     * Url of the resource to be accessed.
     * @param sigMessage
     * The signaling message to be sent.
     *
     * @throws {@link FetchError | FetchError }
     * Thrown if fetch fails.
     * @throws {@link ValidationError | ValidationError }
     * Thrown if the request/response validation fails.
     * @throws {@link InvalidUrlError | InvalidUrlError }
     * Thrown if the provided url is not valid for this request.
     * @throws {@link UnsuccessfulRequestError | UnsuccessfulRequestError }
     * Thrown if response is validated but has status greater than or equal to 400.
     *
     * @returns
     * The signaling message was delivered successfully.
     *
     * @category Device Service Methods
     */
    sendSignalingMessage(url: string, sigMessage: DeviceServiceTypes.CreatePeerconnectionMessage<"request"> | DeviceServiceTypes.ClosePeerconnectionMessage<"request"> | DeviceServiceTypes.SignalingMessage<"request"> | DeviceServiceTypes.ConfigurationMessage<"request"> | DeviceServiceTypes.ExperimentStatusChangedMessage<"request"> | DeviceServiceTypes.LoggingMessage<"request">, options?: {
        headers?: [string, string][];
    }): Promise<void>; /**
     * List Peer Connection
     *
     * @param options.url
     * Url of the Device Service to be used.
     *
     * @throws {@link FetchError | FetchError }
     * Thrown if fetch fails.
     * @throws {@link ValidationError | ValidationError }
     * Thrown if the request/response validation fails.
     * @throws {@link InvalidUrlError | InvalidUrlError }
     * Thrown if the provided url is not valid for this request.
     * @throws {@link UnsuccessfulRequestError | UnsuccessfulRequestError }
     * Thrown if response is validated but has status greater than or equal to 400.
     *
     * @returns
     * The list of all peerconnections.
     *
     * @category Device Service Methods
     */
    listPeerconnections(options?: {
        headers?: [string, string][];
        url?: string;
    }): Promise<DeviceServiceSignatures.ListPeerconnectionsSuccessResponse["body"]>; /**
     * Create a new Peer Connection
     *
     * @param peerconnection
     * The peerconnection to be created.
     * @param options.closedUrl
     * An URL that will be called once the peer connection is closed.
     * @param options.statusChangedUrl
     * An URL that will be called if the status of the peerconnection changes.
     * @param options.url
     * Url of the Device Service to be used.
     *
     * @throws {@link FetchError | FetchError }
     * Thrown if fetch fails.
     * @throws {@link ValidationError | ValidationError }
     * Thrown if the request/response validation fails.
     * @throws {@link InvalidUrlError | InvalidUrlError }
     * Thrown if the provided url is not valid for this request.
     * @throws {@link UnsuccessfulRequestError | UnsuccessfulRequestError }
     * Thrown if response is validated but has status greater than or equal to 400.
     *
     * @returns
     * 201: The peerconnection was created. A JSON representation of the new peer connection is returned.
     * 202: The device service will attempt to create the peerconnection as soon as possible.
     *
     * @category Device Service Methods
     */
    createPeerconnection(peerconnection: DeviceServiceTypes.Peerconnection<"request">, options?: {
        headers?: [string, string][];
        closedUrl?: string;
        statusChangedUrl?: string;
        url?: string;
    }): Promise<DeviceServiceSignatures.CreatePeerconnectionSuccessResponse["body"]>; /**
     * View a peer connection
     *
     * @param url
     * Url of the resource to be accessed.
     *
     * @throws {@link FetchError | FetchError }
     * Thrown if fetch fails.
     * @throws {@link ValidationError | ValidationError }
     * Thrown if the request/response validation fails.
     * @throws {@link InvalidUrlError | InvalidUrlError }
     * Thrown if the provided url is not valid for this request.
     * @throws {@link UnsuccessfulRequestError | UnsuccessfulRequestError }
     * Thrown if response is validated but has status greater than or equal to 400.
     *
     * @returns
     * The JSON Representation of the device peer connection.
     *
     * @category Device Service Methods
     */
    getPeerconnection(url: string, options?: {
        headers?: [string, string][];
    }): Promise<DeviceServiceSignatures.GetPeerconnectionSuccessResponse["body"]>; /**
     * Delete a peer connection
     *
     * @param url
     * Url of the resource to be accessed.
     *
     * @throws {@link FetchError | FetchError }
     * Thrown if fetch fails.
     * @throws {@link ValidationError | ValidationError }
     * Thrown if the request/response validation fails.
     * @throws {@link InvalidUrlError | InvalidUrlError }
     * Thrown if the provided url is not valid for this request.
     * @throws {@link UnsuccessfulRequestError | UnsuccessfulRequestError }
     * Thrown if response is validated but has status greater than or equal to 400.
     *
     * @returns
     * 202: The peerconnection will be deleted as soon as it's closed.
     * 204: The peerconnection was deleted successfully.
     *
     * @category Device Service Methods
     */
    deletePeerconnection(url: string, options?: {
        headers?: [string, string][];
    }): Promise<void>; /**
     * Sets the peerconnection status of a single device.
     *
     * @param url
     * Url of the resource to be accessed.
     * @param body
     * The JSON Representation of the device peer connection.
     * @param device_url
     * URL of the device
     *
     * @throws {@link FetchError | FetchError }
     * Thrown if fetch fails.
     * @throws {@link ValidationError | ValidationError }
     * Thrown if the request/response validation fails.
     * @throws {@link InvalidUrlError | InvalidUrlError }
     * Thrown if the provided url is not valid for this request.
     * @throws {@link UnsuccessfulRequestError | UnsuccessfulRequestError }
     * Thrown if response is validated but has status greater than or equal to 400.
     *
     * @returns
     * OK.
     *
     * @category Device Service Methods
     */
    patchPeerconnectionDeviceStatus(url: string, body: {
        /**
         * The status of the peerconnection.
         */
        status: DeviceServiceTypes.ConnectionStatus<"request">;
        [k: string]: unknown;
    }, device_url: string, options?: {
        headers?: [string, string][];
    }): Promise<void>; /**
     * List experiments
     *
     * @param options.url
     * Url of the Experiment Service to be used.
     *
     * @throws {@link FetchError | FetchError }
     * Thrown if fetch fails.
     * @throws {@link ValidationError | ValidationError }
     * Thrown if the request/response validation fails.
     * @throws {@link InvalidUrlError | InvalidUrlError }
     * Thrown if the provided url is not valid for this request.
     * @throws {@link UnsuccessfulRequestError | UnsuccessfulRequestError }
     * Thrown if response is validated but has status greater than or equal to 400.
     *
     * @returns
     * The list of all experiments.
     *
     * @category Experiment Service Methods
     */
    listExperiments(options?: {
        headers?: [string, string][];
        url?: string;
    }): Promise<ExperimentServiceSignatures.ListExperimentsSuccessResponse["body"]>; /**
     * Create a new experiment
     *
     * @param experiment
     * The experiment to be created.
     * @param options.changedURL
     * An URL that will be called when the experiment status changes.
     * @param options.url
     * Url of the Experiment Service to be used.
     *
     * @throws {@link FetchError | FetchError }
     * Thrown if fetch fails.
     * @throws {@link ValidationError | ValidationError }
     * Thrown if the request/response validation fails.
     * @throws {@link InvalidUrlError | InvalidUrlError }
     * Thrown if the provided url is not valid for this request.
     * @throws {@link UnsuccessfulRequestError | UnsuccessfulRequestError }
     * Thrown if response is validated but has status greater than or equal to 400.
     *
     * @returns
     * 201: The experiment was created. A JSON representation of the new experiment is returned.
     * 202: The experiment was created and will be set to running eventually. A JSON representation of the new experiment is returned.
     *
     * @category Experiment Service Methods
     */
    createExperiment(experiment: ExperimentServiceTypes.Experiment<"request">, options?: {
        headers?: [string, string][];
        changedURL?: string;
        url?: string;
    }): Promise<ExperimentServiceSignatures.CreateExperimentSuccessResponse["body"]>; /**
     * View an experiment.
     *
     * @param url
     * Url of the resource to be accessed.
     *
     * @throws {@link FetchError | FetchError }
     * Thrown if fetch fails.
     * @throws {@link ValidationError | ValidationError }
     * Thrown if the request/response validation fails.
     * @throws {@link InvalidUrlError | InvalidUrlError }
     * Thrown if the provided url is not valid for this request.
     * @throws {@link UnsuccessfulRequestError | UnsuccessfulRequestError }
     * Thrown if response is validated but has status greater than or equal to 400.
     *
     * @returns
     * The JSON Representation of the experiment
     *
     * @category Experiment Service Methods
     */
    getExperiment(url: string, options?: {
        headers?: [string, string][];
    }): Promise<ExperimentServiceSignatures.GetExperimentSuccessResponse["body"]>; /**
     * Update an existing experiment.
     *
     * @param url
     * Url of the resource to be accessed.
     * @param experimentUpdate
     * Update the experiment
     * @param options.changedURL
     * An URL that will be called when the experiment status changes.
     *
     * @throws {@link FetchError | FetchError }
     * Thrown if fetch fails.
     * @throws {@link ValidationError | ValidationError }
     * Thrown if the request/response validation fails.
     * @throws {@link InvalidUrlError | InvalidUrlError }
     * Thrown if the provided url is not valid for this request.
     * @throws {@link UnsuccessfulRequestError | UnsuccessfulRequestError }
     * Thrown if response is validated but has status greater than or equal to 400.
     *
     * @returns
     * 200: The JSON Representation of the changed experiment
     * 202: The JSON Representation of the changed experiment, that will be set to running eventually
     *
     * @category Experiment Service Methods
     */
    updateExperiment(url: string, experimentUpdate: ExperimentServiceTypes.ExperimentUpdate<"request">, options?: {
        headers?: [string, string][];
        changedURL?: string;
    }): Promise<ExperimentServiceSignatures.UpdateExperimentSuccessResponse["body"]>; /**
     * Delete an experiment
     *
     * @param url
     * Url of the resource to be accessed.
     *
     * @throws {@link FetchError | FetchError }
     * Thrown if fetch fails.
     * @throws {@link ValidationError | ValidationError }
     * Thrown if the request/response validation fails.
     * @throws {@link InvalidUrlError | InvalidUrlError }
     * Thrown if the provided url is not valid for this request.
     * @throws {@link UnsuccessfulRequestError | UnsuccessfulRequestError }
     * Thrown if response is validated but has status greater than or equal to 400.
     *
     * @returns
     * The experiment was deleted.
     *
     * @category Experiment Service Methods
     */
    deleteExperiment(url: string, options?: {
        headers?: [string, string][];
    }): Promise<void>; /**
     * List templates
     *
     * @param options.url
     * Url of the Experiment Service to be used.
     *
     * @throws {@link FetchError | FetchError }
     * Thrown if fetch fails.
     * @throws {@link ValidationError | ValidationError }
     * Thrown if the request/response validation fails.
     * @throws {@link InvalidUrlError | InvalidUrlError }
     * Thrown if the provided url is not valid for this request.
     * @throws {@link UnsuccessfulRequestError | UnsuccessfulRequestError }
     * Thrown if response is validated but has status greater than or equal to 400.
     *
     * @returns
     * The list of all templates.
     *
     * @category Experiment Service Methods
     */
    listTemplate(options?: {
        headers?: [string, string][];
        url?: string;
    }): Promise<ExperimentServiceSignatures.ListTemplateSuccessResponse["body"]>; /**
     * Create a new template
     *
     * @param template
     * The template to be created.
     * @param options.url
     * Url of the Experiment Service to be used.
     *
     * @throws {@link FetchError | FetchError }
     * Thrown if fetch fails.
     * @throws {@link ValidationError | ValidationError }
     * Thrown if the request/response validation fails.
     * @throws {@link InvalidUrlError | InvalidUrlError }
     * Thrown if the provided url is not valid for this request.
     * @throws {@link UnsuccessfulRequestError | UnsuccessfulRequestError }
     * Thrown if response is validated but has status greater than or equal to 400.
     *
     * @returns
     * 201: The template was created. A JSON representation of the new template is returned.
     * 202: The template was created and will be set to running eventually. A JSON representation of the new template is returned.
     *
     * @category Experiment Service Methods
     */
    createTemplate(template: ExperimentServiceTypes.Template<"request">, options?: {
        headers?: [string, string][];
        url?: string;
    }): Promise<ExperimentServiceSignatures.CreateTemplateSuccessResponse["body"]>; /**
     * View an template.
     *
     * @param url
     * Url of the resource to be accessed.
     *
     * @throws {@link FetchError | FetchError }
     * Thrown if fetch fails.
     * @throws {@link ValidationError | ValidationError }
     * Thrown if the request/response validation fails.
     * @throws {@link InvalidUrlError | InvalidUrlError }
     * Thrown if the provided url is not valid for this request.
     * @throws {@link UnsuccessfulRequestError | UnsuccessfulRequestError }
     * Thrown if response is validated but has status greater than or equal to 400.
     *
     * @returns
     * The JSON Representation of the template
     *
     * @category Experiment Service Methods
     */
    getTemplate(url: string, options?: {
        headers?: [string, string][];
    }): Promise<ExperimentServiceSignatures.GetTemplateSuccessResponse["body"]>; /**
     * Update an existing template.
     *
     * @param url
     * Url of the resource to be accessed.
     * @param templateUpdate
     * Update the template
     *
     * @throws {@link FetchError | FetchError }
     * Thrown if fetch fails.
     * @throws {@link ValidationError | ValidationError }
     * Thrown if the request/response validation fails.
     * @throws {@link InvalidUrlError | InvalidUrlError }
     * Thrown if the provided url is not valid for this request.
     * @throws {@link UnsuccessfulRequestError | UnsuccessfulRequestError }
     * Thrown if response is validated but has status greater than or equal to 400.
     *
     * @returns
     * 200: The JSON Representation of the changed template
     * 202: The JSON Representation of the changed template, that will be set to running eventually
     *
     * @category Experiment Service Methods
     */
    updateTemplate(url: string, templateUpdate: ExperimentServiceTypes.TemplateUpdate<"request">, options?: {
        headers?: [string, string][];
    }): Promise<ExperimentServiceSignatures.UpdateTemplateSuccessResponse["body"]>; /**
     * Delete an template
     *
     * @param url
     * Url of the resource to be accessed.
     *
     * @throws {@link FetchError | FetchError }
     * Thrown if fetch fails.
     * @throws {@link ValidationError | ValidationError }
     * Thrown if the request/response validation fails.
     * @throws {@link InvalidUrlError | InvalidUrlError }
     * Thrown if the provided url is not valid for this request.
     * @throws {@link UnsuccessfulRequestError | UnsuccessfulRequestError }
     * Thrown if response is validated but has status greater than or equal to 400.
     *
     * @returns
     * The template was deleted.
     *
     * @category Experiment Service Methods
     */
    deleteTemplate(url: string, options?: {
        headers?: [string, string][];
    }): Promise<void>; /**
     * List institutions
     *
     * @param options.url
     * Url of the Federation Service to be used.
     *
     * @throws {@link FetchError | FetchError }
     * Thrown if fetch fails.
     * @throws {@link ValidationError | ValidationError }
     * Thrown if the request/response validation fails.
     * @throws {@link InvalidUrlError | InvalidUrlError }
     * Thrown if the provided url is not valid for this request.
     * @throws {@link UnsuccessfulRequestError | UnsuccessfulRequestError }
     * Thrown if response is validated but has status greater than or equal to 400.
     *
     * @returns
     * The list of all institutions.
     *
     * @category Federation Service Methods
     */
    listInstitutions(options?: {
        headers?: [string, string][];
        url?: string;
    }): Promise<FederationServiceSignatures.ListInstitutionsSuccessResponse["body"]>; /**
     * Create a new institution
     *
     * @param institution
     * The institution to be created.
     * @param options.url
     * Url of the Federation Service to be used.
     *
     * @throws {@link FetchError | FetchError }
     * Thrown if fetch fails.
     * @throws {@link ValidationError | ValidationError }
     * Thrown if the request/response validation fails.
     * @throws {@link InvalidUrlError | InvalidUrlError }
     * Thrown if the provided url is not valid for this request.
     * @throws {@link UnsuccessfulRequestError | UnsuccessfulRequestError }
     * Thrown if response is validated but has status greater than or equal to 400.
     *
     * @returns
     * The institution was created. A JSON representation of the new institution is returned.
     *
     * @category Federation Service Methods
     */
    createInstitution(institution: FederationServiceTypes.Institution<"request">, options?: {
        headers?: [string, string][];
        url?: string;
    }): Promise<FederationServiceSignatures.CreateInstitutionSuccessResponse["body"]>; /**
     * View an institution.
     *
     * @param url
     * Url of the resource to be accessed.
     *
     * @throws {@link FetchError | FetchError }
     * Thrown if fetch fails.
     * @throws {@link ValidationError | ValidationError }
     * Thrown if the request/response validation fails.
     * @throws {@link InvalidUrlError | InvalidUrlError }
     * Thrown if the provided url is not valid for this request.
     * @throws {@link UnsuccessfulRequestError | UnsuccessfulRequestError }
     * Thrown if response is validated but has status greater than or equal to 400.
     *
     * @returns
     * The JSON Representation of the institution
     *
     * @category Federation Service Methods
     */
    getInstitution(url: string, options?: {
        headers?: [string, string][];
    }): Promise<FederationServiceSignatures.GetInstitutionSuccessResponse["body"]>; /**
     * Update an institution.
     *
     * @param url
     * Url of the resource to be accessed.
     * @param institution
     * Update the institution
     *
     * @throws {@link FetchError | FetchError }
     * Thrown if fetch fails.
     * @throws {@link ValidationError | ValidationError }
     * Thrown if the request/response validation fails.
     * @throws {@link InvalidUrlError | InvalidUrlError }
     * Thrown if the provided url is not valid for this request.
     * @throws {@link UnsuccessfulRequestError | UnsuccessfulRequestError }
     * Thrown if response is validated but has status greater than or equal to 400.
     *
     * @returns
     * The JSON Representation of the changed institution
     *
     * @category Federation Service Methods
     */
    updateInstitution(url: string, institution: FederationServiceTypes.Institution<"request">, options?: {
        headers?: [string, string][];
    }): Promise<FederationServiceSignatures.UpdateInstitutionSuccessResponse["body"]>; /**
     * Delete an institution
     *
     * @param url
     * Url of the resource to be accessed.
     *
     * @throws {@link FetchError | FetchError }
     * Thrown if fetch fails.
     * @throws {@link ValidationError | ValidationError }
     * Thrown if the request/response validation fails.
     * @throws {@link InvalidUrlError | InvalidUrlError }
     * Thrown if the provided url is not valid for this request.
     * @throws {@link UnsuccessfulRequestError | UnsuccessfulRequestError }
     * Thrown if response is validated but has status greater than or equal to 400.
     *
     * @returns
     * The institution was delete.
     *
     * @category Federation Service Methods
     */
    deleteInstitution(url: string, options?: {
        headers?: [string, string][];
    }): Promise<void>; /**
     *
     *
     * @throws {@link FetchError | FetchError }
     * Thrown if fetch fails.
     * @throws {@link ValidationError | ValidationError }
     * Thrown if the request/response validation fails.
     * @throws {@link InvalidUrlError | InvalidUrlError }
     * Thrown if the provided url is not valid for this request.
     * @throws {@link UnsuccessfulRequestError | UnsuccessfulRequestError }
     * Thrown if response is validated but has status greater than or equal to 400.
     *
     * @returns
     * Returns the registration parameters for the LTI service.
     *
     * @category LTI Service Methods
     */
    listPlatform(options?: {
        headers?: [string, string][];
    }): Promise<LTIServiceSignatures.ListPlatformSuccessResponse["body"]>; /**
     *
     *
     * @throws {@link FetchError | FetchError }
     * Thrown if fetch fails.
     * @throws {@link ValidationError | ValidationError }
     * Thrown if the request/response validation fails.
     * @throws {@link InvalidUrlError | InvalidUrlError }
     * Thrown if the provided url is not valid for this request.
     * @throws {@link UnsuccessfulRequestError | UnsuccessfulRequestError }
     * Thrown if response is validated but has status greater than or equal to 400.
     *
     * @returns
     * Platform created
     *
     * @category LTI Service Methods
     */
    registerPlatform(options?: {
        headers?: [string, string][];
    }): Promise<LTIServiceSignatures.RegisterPlatformSuccessResponse["body"]>; /**
     *
     *
     * @param url
     * Url of the resource to be accessed.
     *
     * @throws {@link FetchError | FetchError }
     * Thrown if fetch fails.
     * @throws {@link ValidationError | ValidationError }
     * Thrown if the request/response validation fails.
     * @throws {@link InvalidUrlError | InvalidUrlError }
     * Thrown if the provided url is not valid for this request.
     * @throws {@link UnsuccessfulRequestError | UnsuccessfulRequestError }
     * Thrown if response is validated but has status greater than or equal to 400.
     *
     * @returns
     * Returns the platform.
     *
     * @category LTI Service Methods
     */
    getPlatform(url: string, options?: {
        headers?: [string, string][];
    }): Promise<LTIServiceSignatures.GetPlatformSuccessResponse["body"]>; /**
     *
     *
     * @param url
     * Url of the resource to be accessed.
     *
     * @throws {@link FetchError | FetchError }
     * Thrown if fetch fails.
     * @throws {@link ValidationError | ValidationError }
     * Thrown if the request/response validation fails.
     * @throws {@link InvalidUrlError | InvalidUrlError }
     * Thrown if the provided url is not valid for this request.
     * @throws {@link UnsuccessfulRequestError | UnsuccessfulRequestError }
     * Thrown if response is validated but has status greater than or equal to 400.
     *
     * @returns
     * Platform updated
     *
     * @category LTI Service Methods
     */
    updatePlatform(url: string, options?: {
        headers?: [string, string][];
    }): Promise<LTIServiceSignatures.UpdatePlatformSuccessResponse["body"]>; /**
     *
     *
     * @param url
     * Url of the resource to be accessed.
     *
     * @throws {@link FetchError | FetchError }
     * Thrown if fetch fails.
     * @throws {@link ValidationError | ValidationError }
     * Thrown if the request/response validation fails.
     * @throws {@link InvalidUrlError | InvalidUrlError }
     * Thrown if the provided url is not valid for this request.
     * @throws {@link UnsuccessfulRequestError | UnsuccessfulRequestError }
     * Thrown if response is validated but has status greater than or equal to 400.
     *
     * @returns
     * Platform deleted
     *
     * @category LTI Service Methods
     */
    deletePlatform(url: string, options?: {
        headers?: [string, string][];
    }): Promise<void>; /**
     *
     *
     * @param url
     * Url of the resource to be accessed.
     * @param body
     *
     * @throws {@link FetchError | FetchError }
     * Thrown if fetch fails.
     * @throws {@link ValidationError | ValidationError }
     * Thrown if the request/response validation fails.
     * @throws {@link InvalidUrlError | InvalidUrlError }
     * Thrown if the provided url is not valid for this request.
     * @throws {@link UnsuccessfulRequestError | UnsuccessfulRequestError }
     * Thrown if response is validated but has status greater than or equal to 400.
     *
     * @returns
     * returns the verified and parsed LTI message.
     *
     * @category LTI Service Methods
     */
    ltiLogin(url: string, body: {
        /**
         * The issuer of the LTI message.
         */
        iss: string;
        /**
         * The client ID of the LTI message.
         */
        client_id: string;
        /**
         * The deployment ID of the LTI message.
         */
        lti_deployment_id?: string;
        /**
         * The target link URI of the LTI message.
         */
        target_link_uri: string;
        /**
         * The login hint of the LTI message.
         */
        login_hint: string;
        /**
         * The LTI message hint of the LTI message.
         */
        lti_message_hint: string;
    }, options?: {
        headers?: [string, string][];
    }): Promise<LTIServiceSignatures.LtiLoginSuccessResponse["body"]>; /**
     *
     *
     * @param url
     * Url of the resource to be accessed.
     * @param body
     *
     * @throws {@link FetchError | FetchError }
     * Thrown if fetch fails.
     * @throws {@link ValidationError | ValidationError }
     * Thrown if the request/response validation fails.
     * @throws {@link InvalidUrlError | InvalidUrlError }
     * Thrown if the provided url is not valid for this request.
     * @throws {@link UnsuccessfulRequestError | UnsuccessfulRequestError }
     * Thrown if response is validated but has status greater than or equal to 400.
     *
     * @returns
     * returns the verified and parsed LTI message.
     *
     * @category LTI Service Methods
     */
    ltiLaunch(url: string, body: {
        /**
         * The state of the LTI message.
         */
        state: string;
        /**
         * The ID token of the LTI message.
         */
        id_token: string;
    }, options?: {
        headers?: [string, string][];
    }): Promise<LTIServiceSignatures.LtiLaunchSuccessResponse["body"]>; /**
     *
     *
     * @param url
     * Url of the resource to be accessed.
     *
     * @throws {@link FetchError | FetchError }
     * Thrown if fetch fails.
     * @throws {@link ValidationError | ValidationError }
     * Thrown if the request/response validation fails.
     * @throws {@link InvalidUrlError | InvalidUrlError }
     * Thrown if the provided url is not valid for this request.
     * @throws {@link UnsuccessfulRequestError | UnsuccessfulRequestError }
     * Thrown if response is validated but has status greater than or equal to 400.
     *
     * @returns
     * returns the JSON Web Key Set (JWKS) for the tool.
     *
     * @category LTI Service Methods
     */
    ltiJwks(url: string, options?: {
        headers?: [string, string][];
    }): Promise<LTIServiceSignatures.LtiJwksSuccessResponse["body"]>; /**
     *
     *
     * @throws {@link FetchError | FetchError }
     * Thrown if fetch fails.
     * @throws {@link ValidationError | ValidationError }
     * Thrown if the request/response validation fails.
     * @throws {@link InvalidUrlError | InvalidUrlError }
     * Thrown if the provided url is not valid for this request.
     * @throws {@link UnsuccessfulRequestError | UnsuccessfulRequestError }
     * Thrown if response is validated but has status greater than or equal to 400.
     *
     * @returns
     * List all LTI-Resources.
     *
     * @category LTI Service Methods
     */
    listResource(options?: {
        headers?: [string, string][];
    }): Promise<LTIServiceSignatures.ListResourceSuccessResponse["body"]>; /**
     *
     *
     * @param url
     * Url of the resource to be accessed.
     *
     * @throws {@link FetchError | FetchError }
     * Thrown if fetch fails.
     * @throws {@link ValidationError | ValidationError }
     * Thrown if the request/response validation fails.
     * @throws {@link InvalidUrlError | InvalidUrlError }
     * Thrown if the provided url is not valid for this request.
     * @throws {@link UnsuccessfulRequestError | UnsuccessfulRequestError }
     * Thrown if response is validated but has status greater than or equal to 400.
     *
     * @returns
     * Returns the resource.
     *
     * @category LTI Service Methods
     */
    getResource(url: string, options?: {
        headers?: [string, string][];
    }): Promise<LTIServiceSignatures.GetResourceSuccessResponse["body"]>; /**
     *
     *
     * @param url
     * Url of the resource to be accessed.
     * @param body
     *
     * @throws {@link FetchError | FetchError }
     * Thrown if fetch fails.
     * @throws {@link ValidationError | ValidationError }
     * Thrown if the request/response validation fails.
     * @throws {@link InvalidUrlError | InvalidUrlError }
     * Thrown if the provided url is not valid for this request.
     * @throws {@link UnsuccessfulRequestError | UnsuccessfulRequestError }
     * Thrown if response is validated but has status greater than or equal to 400.
     *
     * @returns
     * resource updated
     *
     * @category LTI Service Methods
     */
    updateResource(url: string, body: {
        uri?: string;
        /**
         * The URI of the experiment template.
         */
        experiment_template_uri?: string;
        /**
         * The URI of the students.
         */
        students_uri?: string;
    }, options?: {
        headers?: [string, string][];
    }): Promise<LTIServiceSignatures.UpdateResourceSuccessResponse["body"]>; /**
     *
     *
     * @param url
     * Url of the resource to be accessed.
     *
     * @throws {@link FetchError | FetchError }
     * Thrown if fetch fails.
     * @throws {@link ValidationError | ValidationError }
     * Thrown if the request/response validation fails.
     * @throws {@link InvalidUrlError | InvalidUrlError }
     * Thrown if the provided url is not valid for this request.
     * @throws {@link UnsuccessfulRequestError | UnsuccessfulRequestError }
     * Thrown if response is validated but has status greater than or equal to 400.
     *
     * @returns
     * resource deleted
     *
     * @category LTI Service Methods
     */
    deleteResource(url: string, options?: {
        headers?: [string, string][];
    }): Promise<void>; /**
     *
     *
     * @param url
     * Url of the resource to be accessed.
     *
     * @throws {@link FetchError | FetchError }
     * Thrown if fetch fails.
     * @throws {@link ValidationError | ValidationError }
     * Thrown if the request/response validation fails.
     * @throws {@link InvalidUrlError | InvalidUrlError }
     * Thrown if the provided url is not valid for this request.
     * @throws {@link UnsuccessfulRequestError | UnsuccessfulRequestError }
     * Thrown if response is validated but has status greater than or equal to 400.
     *
     * @returns
     * List all students of the resource.
     *
     * @category LTI Service Methods
     */
    listResourceStudents(url: string, options?: {
        headers?: [string, string][];
    }): Promise<LTIServiceSignatures.ListResourceStudentsSuccessResponse["body"]>; /**
     *
     *
     * @param url
     * Url of the resource to be accessed.
     * @param body
     *
     * @throws {@link FetchError | FetchError }
     * Thrown if fetch fails.
     * @throws {@link ValidationError | ValidationError }
     * Thrown if the request/response validation fails.
     * @throws {@link InvalidUrlError | InvalidUrlError }
     * Thrown if the provided url is not valid for this request.
     * @throws {@link UnsuccessfulRequestError | UnsuccessfulRequestError }
     * Thrown if response is validated but has status greater than or equal to 400.
     *
     * @returns
     * Returns the students.
     *
     * @category LTI Service Methods
     */
    updateResourceStudents(url: string, body: {
        uri: string;
        data: LTIServiceTypes.Student<"request">;
        [k: string]: unknown;
    }[], options?: {
        headers?: [string, string][];
    }): Promise<LTIServiceSignatures.UpdateResourceStudentsSuccessResponse["body"]>; /**
     *
     *
     * @param url
     * Url of the resource to be accessed.
     *
     * @throws {@link FetchError | FetchError }
     * Thrown if fetch fails.
     * @throws {@link ValidationError | ValidationError }
     * Thrown if the request/response validation fails.
     * @throws {@link InvalidUrlError | InvalidUrlError }
     * Thrown if the provided url is not valid for this request.
     * @throws {@link UnsuccessfulRequestError | UnsuccessfulRequestError }
     * Thrown if response is validated but has status greater than or equal to 400.
     *
     * @returns
     * Returns the student.
     *
     * @category LTI Service Methods
     */
    getResourceStudent(url: string, options?: {
        headers?: [string, string][];
    }): Promise<LTIServiceSignatures.GetResourceStudentSuccessResponse["body"]>; /**
     *
     *
     * @param url
     * Url of the resource to be accessed.
     * @param student
     *
     * @throws {@link FetchError | FetchError }
     * Thrown if fetch fails.
     * @throws {@link ValidationError | ValidationError }
     * Thrown if the request/response validation fails.
     * @throws {@link InvalidUrlError | InvalidUrlError }
     * Thrown if the provided url is not valid for this request.
     * @throws {@link UnsuccessfulRequestError | UnsuccessfulRequestError }
     * Thrown if response is validated but has status greater than or equal to 400.
     *
     * @returns
     * Returns the student.
     *
     * @category LTI Service Methods
     */
    updateResourceStudent(url: string, student: LTIServiceTypes.Student<"request">, options?: {
        headers?: [string, string][];
    }): Promise<LTIServiceSignatures.UpdateResourceStudentSuccessResponse["body"]>;
}
//# sourceMappingURL=client.d.ts.map