//@ts-nocheck
/**
 * This file was automatically generated by openapi-codegeneration.
 * DO NOT MODIFY IT BY HAND. Instead, modify the source OpenAPI file,
 * and run openapi-codegeneration to regenerate this file.
 */
"use strict";exports.validateBooking = validate21;const schema6 = {"title":"Booking","description":"A booking in the booking system.","type":"object","required":["ID","Time","Devices","Status","You","External"],"properties":{"ID":{"type":"string","format":"uri","description":"Unique ID of the booking."},"Time":{"$ref":"#/components/schemas/Timeslot"},"Devices":{"type":"array","items":{"type":"string","format":"uri"}},"Type":{"description":"Type of booking. Currently, only one type is defined, but others might follow (e.g. priority booking). If empty, 'normal' is assumed.","type":"string","enum":["normal"]},"Status":{"description":"Current status of the booking. While the booking is pending, it can not be used. Will change automatically and can not be set by user. 'rejected' is set when the initial booking failed, 'cancelled' when the booking was deleted / cancelled after it was once active. The 'active-*' will be used when a device was added after the booking was locked.","type":"string","enum":["pending","booked","rejected","cancelled","active","active-pending","active-rejected"]},"You":{"type":"boolean","description":"If true, this booking was done by you."},"External":{"type":"boolean","description":"Shows whether the booking was done by an external institution."},"Message":{"type":"string","description":"User readable notes about the status of the booking (e.g. if devices are unknown)."}},"x-standalone":true,"x-name":"Booking","x-location":"#/components/schemas/Booking","x-schema-type":"all"};const formats0 = require("ajv-formats/dist/formats").fullFormats.uri;const schema7 = {"title":"Timeslot","description":"A time slot represents a slice of time used for bookings.","type":"object","required":["Start","End"],"properties":{"Start":{"type":"string","description":"Start time of the booking.","format":"date-time"},"End":{"type":"string","description":"End time of the booking.","format":"date-time"}},"x-standalone":true,"x-name":"Timeslot","x-location":"#/components/schemas/Timeslot","x-schema-type":"all"};const formats2 = require("ajv-formats/dist/formats").fullFormats["date-time"];function validate22(data, {instancePath="", parentData, parentDataProperty, rootData=data}={}){let vErrors = null;let errors = 0;if(errors === 0){if(data && typeof data == "object" && !Array.isArray(data)){let missing0;if(((data.Start === undefined) && (missing0 = "Start")) || ((data.End === undefined) && (missing0 = "End"))){validate22.errors = [{instancePath,schemaPath:"#/required",keyword:"required",params:{missingProperty: missing0},message:"must have required property '"+missing0+"'",schema:schema7.required,parentSchema:schema7,data}];return false;}else {if(data.Start !== undefined){let data0 = data.Start;const _errs1 = errors;if(errors === _errs1){if(errors === _errs1){if(typeof data0 === "string"){if(!(formats2.validate(data0))){validate22.errors = [{instancePath:instancePath+"/Start",schemaPath:"#/properties/Start/format",keyword:"format",params:{format: "date-time"},message:"must match format \""+"date-time"+"\"",schema:"date-time",parentSchema:schema7.properties.Start,data:data0}];return false;}}else {validate22.errors = [{instancePath:instancePath+"/Start",schemaPath:"#/properties/Start/type",keyword:"type",params:{type: "string"},message:"must be string",schema:schema7.properties.Start.type,parentSchema:schema7.properties.Start,data:data0}];return false;}}}var valid0 = _errs1 === errors;}else {var valid0 = true;}if(valid0){if(data.End !== undefined){let data1 = data.End;const _errs3 = errors;if(errors === _errs3){if(errors === _errs3){if(typeof data1 === "string"){if(!(formats2.validate(data1))){validate22.errors = [{instancePath:instancePath+"/End",schemaPath:"#/properties/End/format",keyword:"format",params:{format: "date-time"},message:"must match format \""+"date-time"+"\"",schema:"date-time",parentSchema:schema7.properties.End,data:data1}];return false;}}else {validate22.errors = [{instancePath:instancePath+"/End",schemaPath:"#/properties/End/type",keyword:"type",params:{type: "string"},message:"must be string",schema:schema7.properties.End.type,parentSchema:schema7.properties.End,data:data1}];return false;}}}var valid0 = _errs3 === errors;}else {var valid0 = true;}}}}else {validate22.errors = [{instancePath,schemaPath:"#/type",keyword:"type",params:{type: "object"},message:"must be object",schema:schema7.type,parentSchema:schema7,data}];return false;}}validate22.errors = vErrors;return errors === 0;}function validate21(data, {instancePath="", parentData, parentDataProperty, rootData=data}={}){let vErrors = null;let errors = 0;if(errors === 0){if(data && typeof data == "object" && !Array.isArray(data)){let missing0;if(((((((data.ID === undefined) && (missing0 = "ID")) || ((data.Time === undefined) && (missing0 = "Time"))) || ((data.Devices === undefined) && (missing0 = "Devices"))) || ((data.Status === undefined) && (missing0 = "Status"))) || ((data.You === undefined) && (missing0 = "You"))) || ((data.External === undefined) && (missing0 = "External"))){validate21.errors = [{instancePath,schemaPath:"#/required",keyword:"required",params:{missingProperty: missing0},message:"must have required property '"+missing0+"'",schema:schema6.required,parentSchema:schema6,data}];return false;}else {if(data.ID !== undefined){let data0 = data.ID;const _errs1 = errors;if(errors === _errs1){if(errors === _errs1){if(typeof data0 === "string"){if(!(formats0(data0))){validate21.errors = [{instancePath:instancePath+"/ID",schemaPath:"#/properties/ID/format",keyword:"format",params:{format: "uri"},message:"must match format \""+"uri"+"\"",schema:"uri",parentSchema:schema6.properties.ID,data:data0}];return false;}}else {validate21.errors = [{instancePath:instancePath+"/ID",schemaPath:"#/properties/ID/type",keyword:"type",params:{type: "string"},message:"must be string",schema:schema6.properties.ID.type,parentSchema:schema6.properties.ID,data:data0}];return false;}}}var valid0 = _errs1 === errors;}else {var valid0 = true;}if(valid0){if(data.Time !== undefined){const _errs3 = errors;if(!(validate22(data.Time, {instancePath:instancePath+"/Time",parentData:data,parentDataProperty:"Time",rootData}))){vErrors = vErrors === null ? validate22.errors : vErrors.concat(validate22.errors);errors = vErrors.length;}var valid0 = _errs3 === errors;}else {var valid0 = true;}if(valid0){if(data.Devices !== undefined){let data2 = data.Devices;const _errs4 = errors;if(errors === _errs4){if(Array.isArray(data2)){var valid1 = true;const len0 = data2.length;for(let i0=0; i0<len0; i0++){let data3 = data2[i0];const _errs6 = errors;if(errors === _errs6){if(errors === _errs6){if(typeof data3 === "string"){if(!(formats0(data3))){validate21.errors = [{instancePath:instancePath+"/Devices/" + i0,schemaPath:"#/properties/Devices/items/format",keyword:"format",params:{format: "uri"},message:"must match format \""+"uri"+"\"",schema:"uri",parentSchema:schema6.properties.Devices.items,data:data3}];return false;}}else {validate21.errors = [{instancePath:instancePath+"/Devices/" + i0,schemaPath:"#/properties/Devices/items/type",keyword:"type",params:{type: "string"},message:"must be string",schema:schema6.properties.Devices.items.type,parentSchema:schema6.properties.Devices.items,data:data3}];return false;}}}var valid1 = _errs6 === errors;if(!valid1){break;}}}else {validate21.errors = [{instancePath:instancePath+"/Devices",schemaPath:"#/properties/Devices/type",keyword:"type",params:{type: "array"},message:"must be array",schema:schema6.properties.Devices.type,parentSchema:schema6.properties.Devices,data:data2}];return false;}}var valid0 = _errs4 === errors;}else {var valid0 = true;}if(valid0){if(data.Type !== undefined){let data4 = data.Type;const _errs8 = errors;if(typeof data4 !== "string"){validate21.errors = [{instancePath:instancePath+"/Type",schemaPath:"#/properties/Type/type",keyword:"type",params:{type: "string"},message:"must be string",schema:schema6.properties.Type.type,parentSchema:schema6.properties.Type,data:data4}];return false;}if(!(data4 === "normal")){validate21.errors = [{instancePath:instancePath+"/Type",schemaPath:"#/properties/Type/enum",keyword:"enum",params:{allowedValues: schema6.properties.Type.enum},message:"must be equal to one of the allowed values",schema:schema6.properties.Type.enum,parentSchema:schema6.properties.Type,data:data4}];return false;}var valid0 = _errs8 === errors;}else {var valid0 = true;}if(valid0){if(data.Status !== undefined){let data5 = data.Status;const _errs10 = errors;if(typeof data5 !== "string"){validate21.errors = [{instancePath:instancePath+"/Status",schemaPath:"#/properties/Status/type",keyword:"type",params:{type: "string"},message:"must be string",schema:schema6.properties.Status.type,parentSchema:schema6.properties.Status,data:data5}];return false;}if(!(((((((data5 === "pending") || (data5 === "booked")) || (data5 === "rejected")) || (data5 === "cancelled")) || (data5 === "active")) || (data5 === "active-pending")) || (data5 === "active-rejected"))){validate21.errors = [{instancePath:instancePath+"/Status",schemaPath:"#/properties/Status/enum",keyword:"enum",params:{allowedValues: schema6.properties.Status.enum},message:"must be equal to one of the allowed values",schema:schema6.properties.Status.enum,parentSchema:schema6.properties.Status,data:data5}];return false;}var valid0 = _errs10 === errors;}else {var valid0 = true;}if(valid0){if(data.You !== undefined){let data6 = data.You;const _errs12 = errors;if(typeof data6 !== "boolean"){validate21.errors = [{instancePath:instancePath+"/You",schemaPath:"#/properties/You/type",keyword:"type",params:{type: "boolean"},message:"must be boolean",schema:schema6.properties.You.type,parentSchema:schema6.properties.You,data:data6}];return false;}var valid0 = _errs12 === errors;}else {var valid0 = true;}if(valid0){if(data.External !== undefined){let data7 = data.External;const _errs14 = errors;if(typeof data7 !== "boolean"){validate21.errors = [{instancePath:instancePath+"/External",schemaPath:"#/properties/External/type",keyword:"type",params:{type: "boolean"},message:"must be boolean",schema:schema6.properties.External.type,parentSchema:schema6.properties.External,data:data7}];return false;}var valid0 = _errs14 === errors;}else {var valid0 = true;}if(valid0){if(data.Message !== undefined){let data8 = data.Message;const _errs16 = errors;if(typeof data8 !== "string"){validate21.errors = [{instancePath:instancePath+"/Message",schemaPath:"#/properties/Message/type",keyword:"type",params:{type: "string"},message:"must be string",schema:schema6.properties.Message.type,parentSchema:schema6.properties.Message,data:data8}];return false;}var valid0 = _errs16 === errors;}else {var valid0 = true;}}}}}}}}}}else {validate21.errors = [{instancePath,schemaPath:"#/type",keyword:"type",params:{type: "object"},message:"must be object",schema:schema6.type,parentSchema:schema6,data}];return false;}}validate21.errors = vErrors;return errors === 0;}exports.validateDevice = validate24;const schema8 = {"title":"Device","description":"A device might either be a physical/virtual device or a group of device.","type":"object","required":["ID"],"properties":{"ID":{"type":"string","description":"Unique ID of the device. Contains the institution (by having an end point at that institution)","format":"uri"}},"x-standalone":true,"x-name":"Device","x-location":"#/components/schemas/Device","x-schema-type":"all"};function validate24(data, {instancePath="", parentData, parentDataProperty, rootData=data}={}){let vErrors = null;let errors = 0;if(errors === 0){if(data && typeof data == "object" && !Array.isArray(data)){let missing0;if((data.ID === undefined) && (missing0 = "ID")){validate24.errors = [{instancePath,schemaPath:"#/required",keyword:"required",params:{missingProperty: missing0},message:"must have required property '"+missing0+"'",schema:schema8.required,parentSchema:schema8,data}];return false;}else {if(data.ID !== undefined){let data0 = data.ID;const _errs1 = errors;if(errors === _errs1){if(errors === _errs1){if(typeof data0 === "string"){if(!(formats0(data0))){validate24.errors = [{instancePath:instancePath+"/ID",schemaPath:"#/properties/ID/format",keyword:"format",params:{format: "uri"},message:"must match format \""+"uri"+"\"",schema:"uri",parentSchema:schema8.properties.ID,data:data0}];return false;}}else {validate24.errors = [{instancePath:instancePath+"/ID",schemaPath:"#/properties/ID/type",keyword:"type",params:{type: "string"},message:"must be string",schema:schema8.properties.ID.type,parentSchema:schema8.properties.ID,data:data0}];return false;}}}}}}else {validate24.errors = [{instancePath,schemaPath:"#/type",keyword:"type",params:{type: "object"},message:"must be object",schema:schema8.type,parentSchema:schema8,data}];return false;}}validate24.errors = vErrors;return errors === 0;}exports.validateExperiment = validate25;const schema9 = {"title":"Experiment","description":"An experiment describes a set of devices and how they should be connected (potentially among other metadata).","type":"object","required":["Devices"],"properties":{"Devices":{"type":"array","description":"List of devices used in experiment.","items":{"$ref":"#/components/schemas/Device"}},"Description":{"type":"string","description":"User provided description, for example might be a reason for the booking (e.g. maintenance) or a link to the experiment. Might be empty or missing."}},"x-standalone":true,"x-name":"Experiment","x-location":"#/components/schemas/Experiment","x-schema-type":"all"};function validate25(data, {instancePath="", parentData, parentDataProperty, rootData=data}={}){let vErrors = null;let errors = 0;if(errors === 0){if(data && typeof data == "object" && !Array.isArray(data)){let missing0;if((data.Devices === undefined) && (missing0 = "Devices")){validate25.errors = [{instancePath,schemaPath:"#/required",keyword:"required",params:{missingProperty: missing0},message:"must have required property '"+missing0+"'",schema:schema9.required,parentSchema:schema9,data}];return false;}else {if(data.Devices !== undefined){let data0 = data.Devices;const _errs1 = errors;if(errors === _errs1){if(Array.isArray(data0)){var valid1 = true;const len0 = data0.length;for(let i0=0; i0<len0; i0++){const _errs3 = errors;if(!(validate24(data0[i0], {instancePath:instancePath+"/Devices/" + i0,parentData:data0,parentDataProperty:i0,rootData}))){vErrors = vErrors === null ? validate24.errors : vErrors.concat(validate24.errors);errors = vErrors.length;}var valid1 = _errs3 === errors;if(!valid1){break;}}}else {validate25.errors = [{instancePath:instancePath+"/Devices",schemaPath:"#/properties/Devices/type",keyword:"type",params:{type: "array"},message:"must be array",schema:schema9.properties.Devices.type,parentSchema:schema9.properties.Devices,data:data0}];return false;}}var valid0 = _errs1 === errors;}else {var valid0 = true;}if(valid0){if(data.Description !== undefined){let data2 = data.Description;const _errs4 = errors;if(typeof data2 !== "string"){validate25.errors = [{instancePath:instancePath+"/Description",schemaPath:"#/properties/Description/type",keyword:"type",params:{type: "string"},message:"must be string",schema:schema9.properties.Description.type,parentSchema:schema9.properties.Description,data:data2}];return false;}var valid0 = _errs4 === errors;}else {var valid0 = true;}}}}else {validate25.errors = [{instancePath,schemaPath:"#/type",keyword:"type",params:{type: "object"},message:"must be object",schema:schema9.type,parentSchema:schema9,data}];return false;}}validate25.errors = vErrors;return errors === 0;}exports.validateTimeslot = validate22;exports.validateID = validate27;const schema10 = {"type":"string","x-standalone":false,"x-name":"ID","x-location":"#/components/parameters/ID/schema","x-schema-type":"all"};function validate27(data, {instancePath="", parentData, parentDataProperty, rootData=data}={}){let vErrors = null;let errors = 0;if(typeof data !== "string"){validate27.errors = [{instancePath,schemaPath:"#/type",keyword:"type",params:{type: "string"},message:"must be string",schema:schema10.type,parentSchema:schema10,data}];return false;}validate27.errors = vErrors;return errors === 0;}exports.validateBookingRequest = validate28;const schema11 = {"title":"Booking","description":"A booking in the booking system.","type":"object","required":["ID","Time","Devices","Status","You","External"],"properties":{"ID":{"type":"string","format":"uri","description":"Unique ID of the booking."},"Time":{"$ref":"#/components/schemas/Timeslot_request"},"Devices":{"type":"array","items":{"type":"string","format":"uri"}},"Type":{"description":"Type of booking. Currently, only one type is defined, but others might follow (e.g. priority booking). If empty, 'normal' is assumed.","type":"string","enum":["normal"]},"Status":{"description":"Current status of the booking. While the booking is pending, it can not be used. Will change automatically and can not be set by user. 'rejected' is set when the initial booking failed, 'cancelled' when the booking was deleted / cancelled after it was once active. The 'active-*' will be used when a device was added after the booking was locked.","type":"string","enum":["pending","booked","rejected","cancelled","active","active-pending","active-rejected"]},"You":{"type":"boolean","description":"If true, this booking was done by you."},"External":{"type":"boolean","description":"Shows whether the booking was done by an external institution."},"Message":{"type":"string","description":"User readable notes about the status of the booking (e.g. if devices are unknown)."}},"x-standalone":true,"x-name":"BookingRequest","x-location":"#/components/schemas/Booking_request","x-schema-type":"request"};const schema12 = {"title":"Timeslot","description":"A time slot represents a slice of time used for bookings.","type":"object","required":["Start","End"],"properties":{"Start":{"type":"string","description":"Start time of the booking.","format":"date-time"},"End":{"type":"string","description":"End time of the booking.","format":"date-time"}},"x-standalone":true,"x-name":"TimeslotRequest","x-location":"#/components/schemas/Timeslot_request","x-schema-type":"request"};function validate29(data, {instancePath="", parentData, parentDataProperty, rootData=data}={}){let vErrors = null;let errors = 0;if(errors === 0){if(data && typeof data == "object" && !Array.isArray(data)){let missing0;if(((data.Start === undefined) && (missing0 = "Start")) || ((data.End === undefined) && (missing0 = "End"))){validate29.errors = [{instancePath,schemaPath:"#/required",keyword:"required",params:{missingProperty: missing0},message:"must have required property '"+missing0+"'",schema:schema12.required,parentSchema:schema12,data}];return false;}else {if(data.Start !== undefined){let data0 = data.Start;const _errs1 = errors;if(errors === _errs1){if(errors === _errs1){if(typeof data0 === "string"){if(!(formats2.validate(data0))){validate29.errors = [{instancePath:instancePath+"/Start",schemaPath:"#/properties/Start/format",keyword:"format",params:{format: "date-time"},message:"must match format \""+"date-time"+"\"",schema:"date-time",parentSchema:schema12.properties.Start,data:data0}];return false;}}else {validate29.errors = [{instancePath:instancePath+"/Start",schemaPath:"#/properties/Start/type",keyword:"type",params:{type: "string"},message:"must be string",schema:schema12.properties.Start.type,parentSchema:schema12.properties.Start,data:data0}];return false;}}}var valid0 = _errs1 === errors;}else {var valid0 = true;}if(valid0){if(data.End !== undefined){let data1 = data.End;const _errs3 = errors;if(errors === _errs3){if(errors === _errs3){if(typeof data1 === "string"){if(!(formats2.validate(data1))){validate29.errors = [{instancePath:instancePath+"/End",schemaPath:"#/properties/End/format",keyword:"format",params:{format: "date-time"},message:"must match format \""+"date-time"+"\"",schema:"date-time",parentSchema:schema12.properties.End,data:data1}];return false;}}else {validate29.errors = [{instancePath:instancePath+"/End",schemaPath:"#/properties/End/type",keyword:"type",params:{type: "string"},message:"must be string",schema:schema12.properties.End.type,parentSchema:schema12.properties.End,data:data1}];return false;}}}var valid0 = _errs3 === errors;}else {var valid0 = true;}}}}else {validate29.errors = [{instancePath,schemaPath:"#/type",keyword:"type",params:{type: "object"},message:"must be object",schema:schema12.type,parentSchema:schema12,data}];return false;}}validate29.errors = vErrors;return errors === 0;}function validate28(data, {instancePath="", parentData, parentDataProperty, rootData=data}={}){let vErrors = null;let errors = 0;if(errors === 0){if(data && typeof data == "object" && !Array.isArray(data)){let missing0;if(((((((data.ID === undefined) && (missing0 = "ID")) || ((data.Time === undefined) && (missing0 = "Time"))) || ((data.Devices === undefined) && (missing0 = "Devices"))) || ((data.Status === undefined) && (missing0 = "Status"))) || ((data.You === undefined) && (missing0 = "You"))) || ((data.External === undefined) && (missing0 = "External"))){validate28.errors = [{instancePath,schemaPath:"#/required",keyword:"required",params:{missingProperty: missing0},message:"must have required property '"+missing0+"'",schema:schema11.required,parentSchema:schema11,data}];return false;}else {if(data.ID !== undefined){let data0 = data.ID;const _errs1 = errors;if(errors === _errs1){if(errors === _errs1){if(typeof data0 === "string"){if(!(formats0(data0))){validate28.errors = [{instancePath:instancePath+"/ID",schemaPath:"#/properties/ID/format",keyword:"format",params:{format: "uri"},message:"must match format \""+"uri"+"\"",schema:"uri",parentSchema:schema11.properties.ID,data:data0}];return false;}}else {validate28.errors = [{instancePath:instancePath+"/ID",schemaPath:"#/properties/ID/type",keyword:"type",params:{type: "string"},message:"must be string",schema:schema11.properties.ID.type,parentSchema:schema11.properties.ID,data:data0}];return false;}}}var valid0 = _errs1 === errors;}else {var valid0 = true;}if(valid0){if(data.Time !== undefined){const _errs3 = errors;if(!(validate29(data.Time, {instancePath:instancePath+"/Time",parentData:data,parentDataProperty:"Time",rootData}))){vErrors = vErrors === null ? validate29.errors : vErrors.concat(validate29.errors);errors = vErrors.length;}var valid0 = _errs3 === errors;}else {var valid0 = true;}if(valid0){if(data.Devices !== undefined){let data2 = data.Devices;const _errs4 = errors;if(errors === _errs4){if(Array.isArray(data2)){var valid1 = true;const len0 = data2.length;for(let i0=0; i0<len0; i0++){let data3 = data2[i0];const _errs6 = errors;if(errors === _errs6){if(errors === _errs6){if(typeof data3 === "string"){if(!(formats0(data3))){validate28.errors = [{instancePath:instancePath+"/Devices/" + i0,schemaPath:"#/properties/Devices/items/format",keyword:"format",params:{format: "uri"},message:"must match format \""+"uri"+"\"",schema:"uri",parentSchema:schema11.properties.Devices.items,data:data3}];return false;}}else {validate28.errors = [{instancePath:instancePath+"/Devices/" + i0,schemaPath:"#/properties/Devices/items/type",keyword:"type",params:{type: "string"},message:"must be string",schema:schema11.properties.Devices.items.type,parentSchema:schema11.properties.Devices.items,data:data3}];return false;}}}var valid1 = _errs6 === errors;if(!valid1){break;}}}else {validate28.errors = [{instancePath:instancePath+"/Devices",schemaPath:"#/properties/Devices/type",keyword:"type",params:{type: "array"},message:"must be array",schema:schema11.properties.Devices.type,parentSchema:schema11.properties.Devices,data:data2}];return false;}}var valid0 = _errs4 === errors;}else {var valid0 = true;}if(valid0){if(data.Type !== undefined){let data4 = data.Type;const _errs8 = errors;if(typeof data4 !== "string"){validate28.errors = [{instancePath:instancePath+"/Type",schemaPath:"#/properties/Type/type",keyword:"type",params:{type: "string"},message:"must be string",schema:schema11.properties.Type.type,parentSchema:schema11.properties.Type,data:data4}];return false;}if(!(data4 === "normal")){validate28.errors = [{instancePath:instancePath+"/Type",schemaPath:"#/properties/Type/enum",keyword:"enum",params:{allowedValues: schema11.properties.Type.enum},message:"must be equal to one of the allowed values",schema:schema11.properties.Type.enum,parentSchema:schema11.properties.Type,data:data4}];return false;}var valid0 = _errs8 === errors;}else {var valid0 = true;}if(valid0){if(data.Status !== undefined){let data5 = data.Status;const _errs10 = errors;if(typeof data5 !== "string"){validate28.errors = [{instancePath:instancePath+"/Status",schemaPath:"#/properties/Status/type",keyword:"type",params:{type: "string"},message:"must be string",schema:schema11.properties.Status.type,parentSchema:schema11.properties.Status,data:data5}];return false;}if(!(((((((data5 === "pending") || (data5 === "booked")) || (data5 === "rejected")) || (data5 === "cancelled")) || (data5 === "active")) || (data5 === "active-pending")) || (data5 === "active-rejected"))){validate28.errors = [{instancePath:instancePath+"/Status",schemaPath:"#/properties/Status/enum",keyword:"enum",params:{allowedValues: schema11.properties.Status.enum},message:"must be equal to one of the allowed values",schema:schema11.properties.Status.enum,parentSchema:schema11.properties.Status,data:data5}];return false;}var valid0 = _errs10 === errors;}else {var valid0 = true;}if(valid0){if(data.You !== undefined){let data6 = data.You;const _errs12 = errors;if(typeof data6 !== "boolean"){validate28.errors = [{instancePath:instancePath+"/You",schemaPath:"#/properties/You/type",keyword:"type",params:{type: "boolean"},message:"must be boolean",schema:schema11.properties.You.type,parentSchema:schema11.properties.You,data:data6}];return false;}var valid0 = _errs12 === errors;}else {var valid0 = true;}if(valid0){if(data.External !== undefined){let data7 = data.External;const _errs14 = errors;if(typeof data7 !== "boolean"){validate28.errors = [{instancePath:instancePath+"/External",schemaPath:"#/properties/External/type",keyword:"type",params:{type: "boolean"},message:"must be boolean",schema:schema11.properties.External.type,parentSchema:schema11.properties.External,data:data7}];return false;}var valid0 = _errs14 === errors;}else {var valid0 = true;}if(valid0){if(data.Message !== undefined){let data8 = data.Message;const _errs16 = errors;if(typeof data8 !== "string"){validate28.errors = [{instancePath:instancePath+"/Message",schemaPath:"#/properties/Message/type",keyword:"type",params:{type: "string"},message:"must be string",schema:schema11.properties.Message.type,parentSchema:schema11.properties.Message,data:data8}];return false;}var valid0 = _errs16 === errors;}else {var valid0 = true;}}}}}}}}}}else {validate28.errors = [{instancePath,schemaPath:"#/type",keyword:"type",params:{type: "object"},message:"must be object",schema:schema11.type,parentSchema:schema11,data}];return false;}}validate28.errors = vErrors;return errors === 0;}exports.validateBookingResponse = validate31;const schema13 = {"title":"Booking","description":"A booking in the booking system.","type":"object","required":["ID","Time","Devices","Status","You","External"],"properties":{"ID":{"type":"string","format":"uri","description":"Unique ID of the booking."},"Time":{"$ref":"#/components/schemas/Timeslot_response"},"Devices":{"type":"array","items":{"type":"string","format":"uri"}},"Type":{"description":"Type of booking. Currently, only one type is defined, but others might follow (e.g. priority booking). If empty, 'normal' is assumed.","type":"string","enum":["normal"]},"Status":{"description":"Current status of the booking. While the booking is pending, it can not be used. Will change automatically and can not be set by user. 'rejected' is set when the initial booking failed, 'cancelled' when the booking was deleted / cancelled after it was once active. The 'active-*' will be used when a device was added after the booking was locked.","type":"string","enum":["pending","booked","rejected","cancelled","active","active-pending","active-rejected"]},"You":{"type":"boolean","description":"If true, this booking was done by you."},"External":{"type":"boolean","description":"Shows whether the booking was done by an external institution."},"Message":{"type":"string","description":"User readable notes about the status of the booking (e.g. if devices are unknown)."}},"x-standalone":true,"x-name":"BookingResponse","x-location":"#/components/schemas/Booking_response","x-schema-type":"response"};const schema14 = {"title":"Timeslot","description":"A time slot represents a slice of time used for bookings.","type":"object","required":["Start","End"],"properties":{"Start":{"type":"string","description":"Start time of the booking.","format":"date-time"},"End":{"type":"string","description":"End time of the booking.","format":"date-time"}},"x-standalone":true,"x-name":"TimeslotResponse","x-location":"#/components/schemas/Timeslot_response","x-schema-type":"response"};function validate32(data, {instancePath="", parentData, parentDataProperty, rootData=data}={}){let vErrors = null;let errors = 0;if(errors === 0){if(data && typeof data == "object" && !Array.isArray(data)){let missing0;if(((data.Start === undefined) && (missing0 = "Start")) || ((data.End === undefined) && (missing0 = "End"))){validate32.errors = [{instancePath,schemaPath:"#/required",keyword:"required",params:{missingProperty: missing0},message:"must have required property '"+missing0+"'",schema:schema14.required,parentSchema:schema14,data}];return false;}else {if(data.Start !== undefined){let data0 = data.Start;const _errs1 = errors;if(errors === _errs1){if(errors === _errs1){if(typeof data0 === "string"){if(!(formats2.validate(data0))){validate32.errors = [{instancePath:instancePath+"/Start",schemaPath:"#/properties/Start/format",keyword:"format",params:{format: "date-time"},message:"must match format \""+"date-time"+"\"",schema:"date-time",parentSchema:schema14.properties.Start,data:data0}];return false;}}else {validate32.errors = [{instancePath:instancePath+"/Start",schemaPath:"#/properties/Start/type",keyword:"type",params:{type: "string"},message:"must be string",schema:schema14.properties.Start.type,parentSchema:schema14.properties.Start,data:data0}];return false;}}}var valid0 = _errs1 === errors;}else {var valid0 = true;}if(valid0){if(data.End !== undefined){let data1 = data.End;const _errs3 = errors;if(errors === _errs3){if(errors === _errs3){if(typeof data1 === "string"){if(!(formats2.validate(data1))){validate32.errors = [{instancePath:instancePath+"/End",schemaPath:"#/properties/End/format",keyword:"format",params:{format: "date-time"},message:"must match format \""+"date-time"+"\"",schema:"date-time",parentSchema:schema14.properties.End,data:data1}];return false;}}else {validate32.errors = [{instancePath:instancePath+"/End",schemaPath:"#/properties/End/type",keyword:"type",params:{type: "string"},message:"must be string",schema:schema14.properties.End.type,parentSchema:schema14.properties.End,data:data1}];return false;}}}var valid0 = _errs3 === errors;}else {var valid0 = true;}}}}else {validate32.errors = [{instancePath,schemaPath:"#/type",keyword:"type",params:{type: "object"},message:"must be object",schema:schema14.type,parentSchema:schema14,data}];return false;}}validate32.errors = vErrors;return errors === 0;}function validate31(data, {instancePath="", parentData, parentDataProperty, rootData=data}={}){let vErrors = null;let errors = 0;if(errors === 0){if(data && typeof data == "object" && !Array.isArray(data)){let missing0;if(((((((data.ID === undefined) && (missing0 = "ID")) || ((data.Time === undefined) && (missing0 = "Time"))) || ((data.Devices === undefined) && (missing0 = "Devices"))) || ((data.Status === undefined) && (missing0 = "Status"))) || ((data.You === undefined) && (missing0 = "You"))) || ((data.External === undefined) && (missing0 = "External"))){validate31.errors = [{instancePath,schemaPath:"#/required",keyword:"required",params:{missingProperty: missing0},message:"must have required property '"+missing0+"'",schema:schema13.required,parentSchema:schema13,data}];return false;}else {if(data.ID !== undefined){let data0 = data.ID;const _errs1 = errors;if(errors === _errs1){if(errors === _errs1){if(typeof data0 === "string"){if(!(formats0(data0))){validate31.errors = [{instancePath:instancePath+"/ID",schemaPath:"#/properties/ID/format",keyword:"format",params:{format: "uri"},message:"must match format \""+"uri"+"\"",schema:"uri",parentSchema:schema13.properties.ID,data:data0}];return false;}}else {validate31.errors = [{instancePath:instancePath+"/ID",schemaPath:"#/properties/ID/type",keyword:"type",params:{type: "string"},message:"must be string",schema:schema13.properties.ID.type,parentSchema:schema13.properties.ID,data:data0}];return false;}}}var valid0 = _errs1 === errors;}else {var valid0 = true;}if(valid0){if(data.Time !== undefined){const _errs3 = errors;if(!(validate32(data.Time, {instancePath:instancePath+"/Time",parentData:data,parentDataProperty:"Time",rootData}))){vErrors = vErrors === null ? validate32.errors : vErrors.concat(validate32.errors);errors = vErrors.length;}var valid0 = _errs3 === errors;}else {var valid0 = true;}if(valid0){if(data.Devices !== undefined){let data2 = data.Devices;const _errs4 = errors;if(errors === _errs4){if(Array.isArray(data2)){var valid1 = true;const len0 = data2.length;for(let i0=0; i0<len0; i0++){let data3 = data2[i0];const _errs6 = errors;if(errors === _errs6){if(errors === _errs6){if(typeof data3 === "string"){if(!(formats0(data3))){validate31.errors = [{instancePath:instancePath+"/Devices/" + i0,schemaPath:"#/properties/Devices/items/format",keyword:"format",params:{format: "uri"},message:"must match format \""+"uri"+"\"",schema:"uri",parentSchema:schema13.properties.Devices.items,data:data3}];return false;}}else {validate31.errors = [{instancePath:instancePath+"/Devices/" + i0,schemaPath:"#/properties/Devices/items/type",keyword:"type",params:{type: "string"},message:"must be string",schema:schema13.properties.Devices.items.type,parentSchema:schema13.properties.Devices.items,data:data3}];return false;}}}var valid1 = _errs6 === errors;if(!valid1){break;}}}else {validate31.errors = [{instancePath:instancePath+"/Devices",schemaPath:"#/properties/Devices/type",keyword:"type",params:{type: "array"},message:"must be array",schema:schema13.properties.Devices.type,parentSchema:schema13.properties.Devices,data:data2}];return false;}}var valid0 = _errs4 === errors;}else {var valid0 = true;}if(valid0){if(data.Type !== undefined){let data4 = data.Type;const _errs8 = errors;if(typeof data4 !== "string"){validate31.errors = [{instancePath:instancePath+"/Type",schemaPath:"#/properties/Type/type",keyword:"type",params:{type: "string"},message:"must be string",schema:schema13.properties.Type.type,parentSchema:schema13.properties.Type,data:data4}];return false;}if(!(data4 === "normal")){validate31.errors = [{instancePath:instancePath+"/Type",schemaPath:"#/properties/Type/enum",keyword:"enum",params:{allowedValues: schema13.properties.Type.enum},message:"must be equal to one of the allowed values",schema:schema13.properties.Type.enum,parentSchema:schema13.properties.Type,data:data4}];return false;}var valid0 = _errs8 === errors;}else {var valid0 = true;}if(valid0){if(data.Status !== undefined){let data5 = data.Status;const _errs10 = errors;if(typeof data5 !== "string"){validate31.errors = [{instancePath:instancePath+"/Status",schemaPath:"#/properties/Status/type",keyword:"type",params:{type: "string"},message:"must be string",schema:schema13.properties.Status.type,parentSchema:schema13.properties.Status,data:data5}];return false;}if(!(((((((data5 === "pending") || (data5 === "booked")) || (data5 === "rejected")) || (data5 === "cancelled")) || (data5 === "active")) || (data5 === "active-pending")) || (data5 === "active-rejected"))){validate31.errors = [{instancePath:instancePath+"/Status",schemaPath:"#/properties/Status/enum",keyword:"enum",params:{allowedValues: schema13.properties.Status.enum},message:"must be equal to one of the allowed values",schema:schema13.properties.Status.enum,parentSchema:schema13.properties.Status,data:data5}];return false;}var valid0 = _errs10 === errors;}else {var valid0 = true;}if(valid0){if(data.You !== undefined){let data6 = data.You;const _errs12 = errors;if(typeof data6 !== "boolean"){validate31.errors = [{instancePath:instancePath+"/You",schemaPath:"#/properties/You/type",keyword:"type",params:{type: "boolean"},message:"must be boolean",schema:schema13.properties.You.type,parentSchema:schema13.properties.You,data:data6}];return false;}var valid0 = _errs12 === errors;}else {var valid0 = true;}if(valid0){if(data.External !== undefined){let data7 = data.External;const _errs14 = errors;if(typeof data7 !== "boolean"){validate31.errors = [{instancePath:instancePath+"/External",schemaPath:"#/properties/External/type",keyword:"type",params:{type: "boolean"},message:"must be boolean",schema:schema13.properties.External.type,parentSchema:schema13.properties.External,data:data7}];return false;}var valid0 = _errs14 === errors;}else {var valid0 = true;}if(valid0){if(data.Message !== undefined){let data8 = data.Message;const _errs16 = errors;if(typeof data8 !== "string"){validate31.errors = [{instancePath:instancePath+"/Message",schemaPath:"#/properties/Message/type",keyword:"type",params:{type: "string"},message:"must be string",schema:schema13.properties.Message.type,parentSchema:schema13.properties.Message,data:data8}];return false;}var valid0 = _errs16 === errors;}else {var valid0 = true;}}}}}}}}}}else {validate31.errors = [{instancePath,schemaPath:"#/type",keyword:"type",params:{type: "object"},message:"must be object",schema:schema13.type,parentSchema:schema13,data}];return false;}}validate31.errors = vErrors;return errors === 0;}exports.validateDeviceRequest = validate34;const schema15 = {"title":"Device","description":"A device might either be a physical/virtual device or a group of device.","type":"object","required":["ID"],"properties":{"ID":{"type":"string","description":"Unique ID of the device. Contains the institution (by having an end point at that institution)","format":"uri"}},"x-standalone":true,"x-name":"DeviceRequest","x-location":"#/components/schemas/Device_request","x-schema-type":"request"};function validate34(data, {instancePath="", parentData, parentDataProperty, rootData=data}={}){let vErrors = null;let errors = 0;if(errors === 0){if(data && typeof data == "object" && !Array.isArray(data)){let missing0;if((data.ID === undefined) && (missing0 = "ID")){validate34.errors = [{instancePath,schemaPath:"#/required",keyword:"required",params:{missingProperty: missing0},message:"must have required property '"+missing0+"'",schema:schema15.required,parentSchema:schema15,data}];return false;}else {if(data.ID !== undefined){let data0 = data.ID;const _errs1 = errors;if(errors === _errs1){if(errors === _errs1){if(typeof data0 === "string"){if(!(formats0(data0))){validate34.errors = [{instancePath:instancePath+"/ID",schemaPath:"#/properties/ID/format",keyword:"format",params:{format: "uri"},message:"must match format \""+"uri"+"\"",schema:"uri",parentSchema:schema15.properties.ID,data:data0}];return false;}}else {validate34.errors = [{instancePath:instancePath+"/ID",schemaPath:"#/properties/ID/type",keyword:"type",params:{type: "string"},message:"must be string",schema:schema15.properties.ID.type,parentSchema:schema15.properties.ID,data:data0}];return false;}}}}}}else {validate34.errors = [{instancePath,schemaPath:"#/type",keyword:"type",params:{type: "object"},message:"must be object",schema:schema15.type,parentSchema:schema15,data}];return false;}}validate34.errors = vErrors;return errors === 0;}exports.validateDeviceResponse = validate35;const schema16 = {"title":"Device","description":"A device might either be a physical/virtual device or a group of device.","type":"object","required":["ID"],"properties":{"ID":{"type":"string","description":"Unique ID of the device. Contains the institution (by having an end point at that institution)","format":"uri"}},"x-standalone":true,"x-name":"DeviceResponse","x-location":"#/components/schemas/Device_response","x-schema-type":"response"};function validate35(data, {instancePath="", parentData, parentDataProperty, rootData=data}={}){let vErrors = null;let errors = 0;if(errors === 0){if(data && typeof data == "object" && !Array.isArray(data)){let missing0;if((data.ID === undefined) && (missing0 = "ID")){validate35.errors = [{instancePath,schemaPath:"#/required",keyword:"required",params:{missingProperty: missing0},message:"must have required property '"+missing0+"'",schema:schema16.required,parentSchema:schema16,data}];return false;}else {if(data.ID !== undefined){let data0 = data.ID;const _errs1 = errors;if(errors === _errs1){if(errors === _errs1){if(typeof data0 === "string"){if(!(formats0(data0))){validate35.errors = [{instancePath:instancePath+"/ID",schemaPath:"#/properties/ID/format",keyword:"format",params:{format: "uri"},message:"must match format \""+"uri"+"\"",schema:"uri",parentSchema:schema16.properties.ID,data:data0}];return false;}}else {validate35.errors = [{instancePath:instancePath+"/ID",schemaPath:"#/properties/ID/type",keyword:"type",params:{type: "string"},message:"must be string",schema:schema16.properties.ID.type,parentSchema:schema16.properties.ID,data:data0}];return false;}}}}}}else {validate35.errors = [{instancePath,schemaPath:"#/type",keyword:"type",params:{type: "object"},message:"must be object",schema:schema16.type,parentSchema:schema16,data}];return false;}}validate35.errors = vErrors;return errors === 0;}exports.validateExperimentRequest = validate36;const schema17 = {"title":"Experiment","description":"An experiment describes a set of devices and how they should be connected (potentially among other metadata).","type":"object","required":["Devices"],"properties":{"Devices":{"type":"array","description":"List of devices used in experiment.","items":{"$ref":"#/components/schemas/Device_request"}},"Description":{"type":"string","description":"User provided description, for example might be a reason for the booking (e.g. maintenance) or a link to the experiment. Might be empty or missing."}},"x-standalone":true,"x-name":"ExperimentRequest","x-location":"#/components/schemas/Experiment_request","x-schema-type":"request"};function validate36(data, {instancePath="", parentData, parentDataProperty, rootData=data}={}){let vErrors = null;let errors = 0;if(errors === 0){if(data && typeof data == "object" && !Array.isArray(data)){let missing0;if((data.Devices === undefined) && (missing0 = "Devices")){validate36.errors = [{instancePath,schemaPath:"#/required",keyword:"required",params:{missingProperty: missing0},message:"must have required property '"+missing0+"'",schema:schema17.required,parentSchema:schema17,data}];return false;}else {if(data.Devices !== undefined){let data0 = data.Devices;const _errs1 = errors;if(errors === _errs1){if(Array.isArray(data0)){var valid1 = true;const len0 = data0.length;for(let i0=0; i0<len0; i0++){const _errs3 = errors;if(!(validate34(data0[i0], {instancePath:instancePath+"/Devices/" + i0,parentData:data0,parentDataProperty:i0,rootData}))){vErrors = vErrors === null ? validate34.errors : vErrors.concat(validate34.errors);errors = vErrors.length;}var valid1 = _errs3 === errors;if(!valid1){break;}}}else {validate36.errors = [{instancePath:instancePath+"/Devices",schemaPath:"#/properties/Devices/type",keyword:"type",params:{type: "array"},message:"must be array",schema:schema17.properties.Devices.type,parentSchema:schema17.properties.Devices,data:data0}];return false;}}var valid0 = _errs1 === errors;}else {var valid0 = true;}if(valid0){if(data.Description !== undefined){let data2 = data.Description;const _errs4 = errors;if(typeof data2 !== "string"){validate36.errors = [{instancePath:instancePath+"/Description",schemaPath:"#/properties/Description/type",keyword:"type",params:{type: "string"},message:"must be string",schema:schema17.properties.Description.type,parentSchema:schema17.properties.Description,data:data2}];return false;}var valid0 = _errs4 === errors;}else {var valid0 = true;}}}}else {validate36.errors = [{instancePath,schemaPath:"#/type",keyword:"type",params:{type: "object"},message:"must be object",schema:schema17.type,parentSchema:schema17,data}];return false;}}validate36.errors = vErrors;return errors === 0;}exports.validateExperimentResponse = validate38;const schema18 = {"title":"Experiment","description":"An experiment describes a set of devices and how they should be connected (potentially among other metadata).","type":"object","required":["Devices"],"properties":{"Devices":{"type":"array","description":"List of devices used in experiment.","items":{"$ref":"#/components/schemas/Device_response"}},"Description":{"type":"string","description":"User provided description, for example might be a reason for the booking (e.g. maintenance) or a link to the experiment. Might be empty or missing."}},"x-standalone":true,"x-name":"ExperimentResponse","x-location":"#/components/schemas/Experiment_response","x-schema-type":"response"};function validate38(data, {instancePath="", parentData, parentDataProperty, rootData=data}={}){let vErrors = null;let errors = 0;if(errors === 0){if(data && typeof data == "object" && !Array.isArray(data)){let missing0;if((data.Devices === undefined) && (missing0 = "Devices")){validate38.errors = [{instancePath,schemaPath:"#/required",keyword:"required",params:{missingProperty: missing0},message:"must have required property '"+missing0+"'",schema:schema18.required,parentSchema:schema18,data}];return false;}else {if(data.Devices !== undefined){let data0 = data.Devices;const _errs1 = errors;if(errors === _errs1){if(Array.isArray(data0)){var valid1 = true;const len0 = data0.length;for(let i0=0; i0<len0; i0++){const _errs3 = errors;if(!(validate35(data0[i0], {instancePath:instancePath+"/Devices/" + i0,parentData:data0,parentDataProperty:i0,rootData}))){vErrors = vErrors === null ? validate35.errors : vErrors.concat(validate35.errors);errors = vErrors.length;}var valid1 = _errs3 === errors;if(!valid1){break;}}}else {validate38.errors = [{instancePath:instancePath+"/Devices",schemaPath:"#/properties/Devices/type",keyword:"type",params:{type: "array"},message:"must be array",schema:schema18.properties.Devices.type,parentSchema:schema18.properties.Devices,data:data0}];return false;}}var valid0 = _errs1 === errors;}else {var valid0 = true;}if(valid0){if(data.Description !== undefined){let data2 = data.Description;const _errs4 = errors;if(typeof data2 !== "string"){validate38.errors = [{instancePath:instancePath+"/Description",schemaPath:"#/properties/Description/type",keyword:"type",params:{type: "string"},message:"must be string",schema:schema18.properties.Description.type,parentSchema:schema18.properties.Description,data:data2}];return false;}var valid0 = _errs4 === errors;}else {var valid0 = true;}}}}else {validate38.errors = [{instancePath,schemaPath:"#/type",keyword:"type",params:{type: "object"},message:"must be object",schema:schema18.type,parentSchema:schema18,data}];return false;}}validate38.errors = vErrors;return errors === 0;}exports.validateTimeslotRequest = validate29;exports.validateTimeslotResponse = validate32;exports.validateIDRequest = validate40;const schema19 = {"type":"string","x-standalone":false,"x-name":"IDRequest","x-location":"#/components/parameters/ID/schema_request","x-schema-type":"request"};function validate40(data, {instancePath="", parentData, parentDataProperty, rootData=data}={}){let vErrors = null;let errors = 0;if(typeof data !== "string"){validate40.errors = [{instancePath,schemaPath:"#/type",keyword:"type",params:{type: "string"},message:"must be string",schema:schema19.type,parentSchema:schema19,data}];return false;}validate40.errors = vErrors;return errors === 0;}exports.validateIDResponse = validate41;const schema20 = {"type":"string","x-standalone":false,"x-name":"IDResponse","x-location":"#/components/parameters/ID/schema_response","x-schema-type":"response"};function validate41(data, {instancePath="", parentData, parentDataProperty, rootData=data}={}){let vErrors = null;let errors = 0;if(typeof data !== "string"){validate41.errors = [{instancePath,schemaPath:"#/type",keyword:"type",params:{type: "string"},message:"must be string",schema:schema20.type,parentSchema:schema20,data}];return false;}validate41.errors = vErrors;return errors === 0;}